"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var request = require("request");
var AccessibilityService = /** @class */ (function () {
    function AccessibilityService() {
    }
    AccessibilityService.prototype.init = function (apiServiceManager, server, config) {
        var _this = this;
        this.server = server;
        this.baseUrl = apiServiceManager.BaseUrl + (config['accessibilityAddress'] || '/accessibility');
        //console.log(this.baseUrl);
        server.get(this.baseUrl, function (req, res) {
            var id = req.query.url;
            _this.getAccessibility(id, res);
        });
    };
    AccessibilityService.prototype.shutdown = function () { };
    AccessibilityService.prototype.getAccessibility = function (url, res) {
        console.log('Accessibility request: ' + url);
        var options = {
            url: url,
            headers: { 'Accept': 'application/json' } //Required to receive a reply in json format instead of xml
        };
        request(options, function (error, response) {
            if (!error && response.statusCode == 200) {
                res.json(response);
            }
            else {
                res.statusCode = 404;
                res.end();
            }
        });
    };
    return AccessibilityService;
}());
exports.AccessibilityService = AccessibilityService;
//# sourceMappingURL=AccessibilityService.js.map